%option noyywrap
%{
#include "config.tab.h"
%}

DIGIT	[0-9]
ALPHA	[a-zA-Z]
SYMCHR	[a-zA-Z0-9\-_:/+]

%%

[#][^\n]*		return COMMENT;

"collector-config"	return T_COLLECTOR_CONFIG;
"viewer-1-config"	return T_VIEWER_1_CONFIG;
"viewer-2-config"	return T_VIEWER_2_CONFIG;
"offer"			return T_OFFER;
"members"		return T_MEMBERS;
"directory_frequency"	return T_DIRECTORY_FREQUENCY;
"server-config"		return T_SERVER_CONFIG;
"command"		return T_COMMAND;
"db_host"		return T_DB_HOST;
"db_name"		return T_DB_NAME;
"db_password"		return T_DB_PASSWORD;
"db_user"		return T_DB_USER;
"delay"			return T_DELAY;
"max_lines"		return T_MAX_LINES;
"dependencies"		return T_DEPENDENCIES;
"dependency"		return T_DEPENDENCY;
"destination"		return T_DESTINATION;
"destinations"		return T_DESTINATIONS;
"filter"		return T_FILTER;
"frequency"		return T_FREQUENCY;
"heading"		return T_HEADING;
"histogram"		return T_HISTOGRAM;
"identity"		return T_IDENTITY;
"input_timeout"		return T_INPUT_TIMEOUT;
"interface"		return T_INTERFACE;
"log_file"		return T_LOG_FILE;
"log_level"		return T_LOG_LEVEL;
"machine"		return T_MACHINE;
"machines"		return T_MACHINES;
"maxwait"		return T_MAXWAIT;
"name"			return T_NAME;
"role"			return T_ROLE;
"roles"			return T_ROLES;
"output"		return T_OUTPUT;
"outputs"		return T_OUTPUTS;
"parameter"		return T_PARAMETER;
"password"		return T_PASSWORD;
"port"			return T_PORT;
"proxy"			return T_PROXY;
"query"			return T_QUERY;
"receiver-config"	return T_RECEIVER_CONFIG;
"refinery-config"	return T_REFINERY_CONFIG;
"scalar"		return T_SCALAR;
"sender-config"		return T_SENDER_CONFIG;
"sendsize"		return T_SENDSIZE;
"sensor"		return T_SENSOR;
"sensors"		return T_SENSORS;
"signature"		return T_SIGNATURE;
"site"			return T_SITE;
"source"		return T_SOURCE;
"table"			return T_TABLE;
"type"			return T_TYPE;
"url"			return T_URL;
"viewer_inputs"		return T_VIEWER_INPUTS;
"input"			return T_INPUT;
"data_rows"		return T_DATA_ROWS;
"data_freq"		return T_DATA_FREQ;
"data_file"		return T_DATA_FILE;
"data_name"		return T_DATA_NAME;
"user"			return T_USER;
"users"			return T_USERS;
"watcher-config"	return T_WATCHER_CONFIG;

{ALPHA}+{SYMCHR}*	return SYMBOL;
{DIGIT}+\.{DIGIT}+\.{DIGIT}+\.{DIGIT}+	return IP_ADDRESS;
[ \t]			return BLANK;
[\r\n]			return LFEED;
\"[^"]+\"		return STRING;
{DIGIT}+		return NUMBER;
=			return EQUALS;
,			return COMMA;
\{			return LBRACE;
\}			return RBRACE;
\;			return SEMICOLON;

%%
void use_yyunput() { yyunput(0,0); }









