/* -*- Mode:C++ -*- */

/* ---------------------------------------------------------------------- */

#ifdef LIBPQ
#include "libpq/libpq-fe.h"
#endif

/* ---------------------------------------------------------------------- */

typedef struct _table
{
    char *name;
    char *signature;
    char last[23];
    struct _table *next;
} table;

typedef struct _dbsession
{
#ifdef LIBPQ
    PGconn *pgc;
#else
    str *buffer;
#endif
} dbsession;

typedef char *relation_cell;

typedef struct _relation
{
    unsigned long rows;
    unsigned long columns;
    relation_cell *cells;
} relation;

/* ---------------------------------------------------------------------- */

table *new_table(char *name, char *signature, char *last, table *next);
table *read_tables(dbsession *session, char *db_user, int *ok);
unsigned long get_next(dbsession *session, int *ok);
table *free_table(table *t);

dbsession *db_open(char *db_host, char *db_name, char *db_user, char *db_password);
int db_send_commands(dbsession *session, str *s, char **errmsg);
void db_close(dbsession *session);

relation *new_relation();
void free_relation(relation *x);
relation *do_query(dbsession *session, char *cmd, int *ok);

void db_cleanup();

/* ---------------------------------------------------------------------- */







