/* -*- Mode: C++ -*- */

/* ---------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include "tools.h"
#include "destination.h"

destination *current_destinations;

/* ---------------------------------------------------------------------- */

destination *new_destination(destination *next,
			     char *url, int sendsize, int maxwait)
{
    destination *res=(destination*)smalloc(sizeof(destination));

    res->hostname=NULL;
    res->port=0;
    res->path=NULL;
    res->lastdelivery=0;
    res->lasthttperror=0;
    res->maxwait=maxwait;
    res->sendsize=sendsize;
    res->proxy_name=NULL;
    res->proxy_port=0;
    res->proxy_user=NULL;
    res->proxy_password=NULL;
    res->credentials=NULL;
    res->sensor_filters=NULL;
    res->machine_filters=NULL;
    res->s=new_str();

    if (split_url(url,&(res->hostname),&(res->port),&(res->path))==true)
    {
	res->next=next;
    }
    else
    {
	sfree(res);
	res=NULL;
    };

    return res;
}

destination *free_destination(destination *x)
{
    destination *res=NULL;

    if (x!=NULL)
    {
	res=x->next;

	#define SFREE(X) { if (x->X!=NULL) { sfree(x->X); x->X=NULL; }; }

	SFREE(hostname);
	x->port=-1;
	SFREE(path);
	x->sendsize=-1;
	SFREE(password);
	SFREE(proxy_name);
	x->proxy_port=-1;
	SFREE(proxy_user);
	SFREE(proxy_password);
	SFREE(credentials);
	free_str(x->s); x->s=NULL;

	cleanup_sensor_filters(&(x->sensor_filters));
	cleanup_machine_filters(&(x->machine_filters));

	sfree(x); x=NULL;
    };

    return res;
}

/* ---------------------------------------------------------------------- */

void cleanup_destinations()
{
    while (current_destinations!=NULL)
	current_destinations=free_destination(current_destinations);
}

/* ---------------------------------------------------------------------- */
