/* -*- Mode: C++ -*- */

/* ---------------------------------------------------------------------- */

#ifndef _DESTINATION_
#define _DESTINATION_

#include "filters.h"

/* ---------------------------------------------------------------------- */

#define DESTINATIONS 100
#define BUFSIZE 10000

typedef struct _destination
{
    int maxwait;
    int sendsize;
    unsigned long lastdelivery;
    unsigned long lasthttperror;

    char *password;
    char *hostname; int port; char *path;
    char *proxy_name; int proxy_port;
    char *proxy_user; char *proxy_password;
    char *credentials;
    sensor_filter *sensor_filters;
    machine_filter *machine_filters;
    str *s;
    struct _destination *next;
} destination;

extern destination *current_destinations;

/* ---------------------------------------------------------------------- */

destination *new_destination(destination *next,
			     char *url, int sendsize, int maxwait);
destination *free_destination(destination *x);
void cleanup_destinations();

/* ---------------------------------------------------------------------- */

#endif _DESTINATION_

/* ---------------------------------------------------------------------- */
