/* -*- Mode: C++ -*- */

/* ---------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include "tools.h"
#include "filters.h"

/* ---------------------------------------------------------------------- */

sensor_filter *new_sensor_filter(sensor_filter *next, char *machine, char *sensor)
{
    sensor_filter *res=(sensor_filter*)smalloc(sizeof(sensor_filter));
    res->machine=sstrdup(machine);
    res->sensor=sstrdup(sensor);
    res->next=next;
    return res;
}

sensor_filter *free_sensor_filter(sensor_filter *x)
{
    sensor_filter *res=NULL;

    if (x!=NULL)
    {
	if (x->machine!=NULL) sfree(x->machine);
	if (x->sensor!=NULL) sfree(x->sensor);
	res=x->next;
	sfree(x);
    };

    return res;
}

void cleanup_sensor_filters(sensor_filter **x)
{
    while (*x!=NULL)
	*x=free_sensor_filter(*x);
}

/* ---------------------------------------------------------------------- */

machine_filter *new_machine_filter(machine_filter *next, char *machine)
{
    machine_filter *res=(machine_filter*)smalloc(sizeof(machine_filter));
    res->machine=sstrdup(machine);
    res->next=next;
    return res;
}

machine_filter *free_machine_filter(machine_filter *x)
{
    machine_filter *res=NULL;

    if (x!=NULL)
    {
	if (x->machine!=NULL) sfree(x->machine);
	res=x->next;
	sfree(x);
    };

    return res;
}

void cleanup_machine_filters(machine_filter **x)
{
    while (*x!=NULL)
	*x=free_machine_filter(*x);
}

/* ---------------------------------------------------------------------- */

