/* -*- Mode: C++ -*- */

/* ---------------------------------------------------------------------- */

#include <stdlib.h>
#include <netinet/in.h>

/* ---------------------------------------------------------------------- */

#define SOURCES 100
#define BUFSIZE 10000

typedef enum
{
    st_unknown=0,
    st_watcher,
    st_collector,
    st_sender,
    st_server,
    st_viewer_1
} source_t;

typedef struct _source
{
    int src;
    struct _source *next;
    char challenge[17];
    char buffer[BUFSIZE];
    char description[100];
    source_t tpe;
    union
    {
	struct
	{
	    pid_t pid;
	    int frequency;
	    char *name, *command, *parameter;
	} watcher;
	struct
	{
	} collector;
	struct
	{
	} sender;
	struct
	{
	    char *user;
	} server;
    } t;
    enum { sstate_unauthenticated=0, sstate_authenticated } state;
} source;

extern source *current_sources;

/* ---------------------------------------------------------------------- */

typedef struct _socket_buf
{
    char *buf;
    int *socket;
    int cur, cnt, avl;
} socket_buf;

socket_buf *new_socket_buf(int *socket);
socket_buf *free_socket_buf(socket_buf *sb);
int read_char(socket_buf *sb);
int read_line(socket_buf *sb, str *s);
void flush_buf(socket_buf *sb);

/* ---------------------------------------------------------------------- */

source *new_source(source_t t, char *description);
source *free_source(source *x);
int process_sources(int input_timeout,
		    int *accept_fd, struct sockaddr_in *client);
void shutdown_sources();
void cleanup_sources();

int re_initialise_input(interface *src);
int re_initialise_output(interface *dst);
int shutdown_socket(int sock, char *fromto, interface *i);
char *sockaddr_to_ascii(struct sockaddr_in *c);

void send_challenge(source *s);
char *authenticate_partner(char *line, source *s, user *u);
int identify_self(int sock, user *me);

/* ---------------------------------------------------------------------- */

