/* -*- Mode:C++ -*- */

/* ---------------------------------------------------------------------- */

#ifndef true
#define true (0==0)
#endif

#ifndef false
#define false (0==1)
#endif

extern int main_fd;

/* ---------------------------------------------------------------------- */

/* sleep for CPU_SAVER seconds if no config available ... */
#define CPU_SAVER 5

/* ---------------------------------------------------------------------- */

#ifdef MEMDEBUG
void md_lst(const char *fn, int ln);
#else
#define md_lst(fn,ln) {}
#endif

#define smalloc(x) int_smalloc(x,__FILE__,__LINE__)
#define srealloc(x,y) int_srealloc(x,y,__FILE__,__LINE__)
#define sfree(x) int_sfree(x,__FILE__,__LINE__)
#define sstrdup(x) int_sstrdup(x,__FILE__,__LINE__)

void *int_smalloc(unsigned long s, const char *fn, int ln);
void *int_srealloc(void *b, unsigned long s, const char *fn, int ln);
void int_sfree(void *b, const char *fn, int ln);
char *int_sstrdup(const char *x, const char *f, int l);
#define stripquotes(x) int_stripquotes(x,__FILE__,__LINE__);
char *int_stripquotes(const char *x, const char *fn, int ln);

/* ---------------------------------------------------------------------- */

char *iso_timestamp();
unsigned long iso_to_epoch(char *x);

/* ---------------------------------------------------------------------- */

typedef struct _str
{
    int cnt, avl;
    char *buf;
} str;

int clen(str *x);
char *cstr(str *x);

#define new_str() int_new_str(__FILE__,__LINE__)
str *int_new_str(const char *fn, int ln);

#define free_str(x) int_free_str(x,__FILE__,__LINE__)
void int_free_str(str *x, const char *fn, int ln);

#define reset_str(x) int_reset_str(x,__FILE__,__LINE__)
void int_reset_str(str *x, const char *fn, int ln);

#define add_str(x,a) int_add_str(x,a,__FILE__,__LINE__)
void int_add_str(str *x, char *add, const char *fn, int ln);

#define cpy_str(x,a,c) int_cpy_str(x,a,c,__FILE__,__LINE__)
void int_cpy_str(str *x, char *add, int count, const char *fn, int ln);

int write_string(str *s, int socket);

/* ---------------------------------------------------------------------- */

char *extract_first_line(char *buffer, int *bcnt);
char *extract_last_line(char *buffer, int *bcnt);
char *extract_int(char *buf, int *x);
char *expect(char *buf, char *cmp);

/* ---------------------------------------------------------------------- */

void parse_commands(int argc, char **argv, char **cnf, char **log);

/* ---------------------------------------------------------------------- */

char *expect(char *buf, char *cmp);
int split_url(char *url, char **hostname, int *port, char **path);

/* ---------------------------------------------------------------------- */

void install_handler();
extern volatile int end;

/* ---------------------------------------------------------------------- */

char *base64_encode(unsigned char *data, int count);
#define base64_decode(d,c) int_base64_decode(d,c,__FILE__,__LINE__)
char *int_base64_decode(char *data, int *count, const char *fn, int ln);

/* ---------------------------------------------------------------------- */

char *mac_encrypt(char *buf, unsigned long len);
void cbc_encrypt(char *pwd, char *buf, unsigned long len);
void cbc_decrypt(char *pwd, char *buf, unsigned long len);

/* ---------------------------------------------------------------------- */

void tools_cleanup();

/* ---------------------------------------------------------------------- */

char *ulong_to_dotted(unsigned long x);

/* ---------------------------------------------------------------------- */

int is_ws(int ch);
int skip_ws(FILE *f);

/* ---------------------------------------------------------------------- */

/* for debugging, take 8 bytes from 'buf', return ascii-hex */
char *tohex(char *buf, int length);

/* ---------------------------------------------------------------------- */

